#ifndef _FSAYS_KEYBOARD_H
#define _FSAYS_KEYBOARD_H

#include <linux/input.h>
#include <semaphore.h>
#include "fsayskeystroke.h"
#include "fsaysremotekey.h"

#define LOCAL_ESCAPE 27
#define MY_SEC          1000000
#define MY_TSEC          100000
#define MY_FHSEC          50000
#define MY_HSEC           10000
#define MY_FMSEC           5000  
#define MY_MSEC            1000  
#define MY_USEC               1  

class FSaysKeyboard
{
    public:
        // constructors
        FSaysKeyboard(char* eventPath);
        ~FSaysKeyboard();
    
        void foo(void);
        int getStatus();
        void alarm_func(int t);
        void processKeys(void);

    private:
        FSaysKeystroke* _p_firstKeystroke;
        FSaysKeystroke* _p_lastKeystroke;
        FSaysRemoteKey* _p_previousRemoteKey;
        FSaysRemoteKey* _p_currentRemoteKey;

        void startKey();
        void endKey();

        void deleteNkeyStrokes(int n);

        int getche(void);
        int getch(void);

        bool handleSingleKey(int key);
        bool handleAZ(int key);
        bool handleEscape();
        bool handleEscape3chars(int key2, int key3);
        bool handleEscape4chars(int key2, int key3, int key4);
        bool handleEscape5chars(int key2, int key3, int key4, int key5);

        void handler(void *ptr); 
        // member variables
        int status;
        struct input_event event; 
        struct input_event event_end;
        int fd;
        int previousRemoteKey;
        int currentRemoteKey;
        int keystrokeIndex;

        bool keepRunning;
        pthread_t thread_a;
        sem_t _mutex;
};
#endif
