#include <termios.h>
#include <stdio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <linux/input.h>
#include <linux/uinput.h>
#include "fsaysuinput.h"

#define die(str, args...) \
    do \
    { \
        perror(str); \
        exit(EXIT_FAILURE); \
    } while(0)

FSaysUInput::FSaysUInput(void)
{
    struct uinput_user_dev uidev;
    int            dx, dy;
    int            i;
    int            code;
    int            count;
    int index=0;
    int key;
    int tkey;
    struct timeval t1;
    char c;

    int result = 0;

    printf("opening device...\n");
    fd = open("/dev/uinput", O_WRONLY | O_NONBLOCK | O_CREAT);
    if(fd < 0){ die("error: open");     }
    printf("opened device result:%d..\n", fd);

    result = ioctl(fd, UI_SET_EVBIT, EV_KEY);
    printf("ioctl(fd, UI_SET_EVBIT, EV_KEY):%d..\n", result);
    if(result < 0){ die("error: ioctl"); }
 
    result = ioctl(fd, UI_SET_KEYBIT, BTN_LEFT);
    printf("ioctl(fd, UI_SET_KEYBIT, BTN_LEFT):%d..\n", result);    
    if(result < 0) { die("error: ioctl"); }

    result = ioctl(fd, UI_SET_EVBIT, EV_REL);
    printf("ioctl(fd, UI_SET_EVBIT, EV_REL):%d..\n", result);
    if(result < 0){ die("error: ioctl");}

    result = ioctl(fd, UI_SET_RELBIT, REL_X);
    printf("ioctl(fd, UI_SET_RELBIT, REL_X):%d..\n", result);
    if(result < 0){ die("error: ioctl");}

    result = ioctl(fd, UI_SET_RELBIT, REL_Y);
    printf("ioctl(fd, UI_SET_RELBIT, REL_Y):%d..\n", result);
    if(result < 0) { die("error: ioctl");}

    for (i=0; i < 255; i++)
    {
        ioctl(fd, UI_SET_KEYBIT, i);
    }
    memset(&uidev, 0, sizeof(uidev));
    snprintf(uidev.name, UINPUT_MAX_NAME_SIZE, "uinput-fsays");
    uidev.id.bustype = BUS_USB;
    uidev.id.vendor  = 0x1;
    uidev.id.product = 0x1;
    uidev.id.version = 2;
    //uidev.absmax[ABS_X] = 1024; 
    //uidev.absmax[ABS_Y] = 1024;

    result = write(fd, &uidev, sizeof(uidev));
    printf("write(fd, &uidev, sizeof(uidev)):%d..\n", result);
    if(result < 0) { die("error: write");}


    result = ioctl(fd, UI_DEV_CREATE);
    printf("ioctl(fd, UI_DEV_CREATE):%d..\n", result);
    if(result < 0){ die("error: ioctl");}

    memset(&ev, 0, sizeof(ev));

    status = (result >= 0) ? 0 : -1;
}


int FSaysUInput::getStatus()
{
    return status;
}

FSaysUInput::~FSaysUInput()
{
    printf("write(fd, &ev, sizeof(ev): %d\n", status);
    status = ioctl(fd, UI_DEV_DESTROY);
    printf("ioctl(fd, UI_DEV_DESTROY):%d..\n", status);

    if(status < 0)
    die("error: ioctl");

    printf("Closing device...\n");
    close(fd);
    printf("Closed device...\n");
}


